/*---------------------------------------------------------------------------
 * 
 * Synopsis
 * --------
 * Aggregate header file for sockets under either BSD or Winsock.
 *
 * Author
 * ------
 * Raymond McKendall
 * November 1998 -- January 1999
 *
 *--------------------------------------------------------------------------*/

#ifndef _BSDWINSOCK_H_
#define _BSDWINSOCK_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>

#ifdef _WIN32
#include <winsock.h>
#endif

#ifndef _WIN32
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>  /* Must follow <netinet/in.h> */
#define INVALID_SOCKET -1
#define SOCKET_ERROR   -1
typedef int SOCKET;
#endif

#ifdef __mips
#include <unistd.h>
#include <sys/types.h>
#include <bstring.h>
#include <sys/time.h>
#endif

typedef struct in_addr     NetAddress;
typedef struct hostent     HostEntry;
typedef struct sockaddr_in SocketAddressIN;
typedef struct sockaddr    SocketAddress;

#define PROTOCOL 0   /* for socket() */

/* Prototypes for bsd-winsock.c */

#ifdef __cplusplus
extern "C" {
#endif

int  comm_initialize_sockets(void);
void comm_terminate_sockets(void);
int  comm_lasterror(void);
void comm_error(char*);
void comm_close_socket(SOCKET sfd);

#ifdef __cplusplus
}
#endif

#endif
